GridPos = {}

function GridPos.make(x, y)
	local p = {x, y}
	setmetatable(p, GridPos)
	return p
end

function GridPos.__add(p1, p2)
	return GridPos.make(p1[1]+p2[1], p1[2]+p2[2])
end

function GridPos.__sub(p1, p2)
	return GridPos.make(p1[1]-p2[1], p1[2]-p2[2])
end


-- calculate Manhattan (l1) distance
function GridPos.distance(p1, p2)
	return math.abs(p1[1]-p2[1]) + math.abs(p1[2]-p2[2])
end

function GridPos.isAdjacent(p1, p2)
	return math.abs(p1[1]-p2[1]) <= 1 and math.abs(p1[2]-p2[2]) <= 1
end
