module('entity.door', package.seeall)


function init(e, param)
	local pos = Arkham.Entity.getPosition(e)
	local useRegion = param and string.find(param, 'useregion')
	
	scriptEntities[e] = {
		e = e,
		closedTile = Arkham.Map.getChar(pos),
		useRegion = useRegion
	}
	
	if useRegion then
		local rgnName = Arkham.Entity.getName(e)
		scriptEntities[e].region = Arkham.Map.getRegionCells(rgnName)
	end
	
	if param and string.find(param, 'startopen') then
		sendMessage(e, e, 'open')
	else
		sendMessage(e, e, 'close')
	end
end


--~ function think(e)
--~ 	while true do
--~ 		wait(1)
--~ 		sendMessage(e, e, 'close')
--~ 		wait(1)
--~ 		sendMessage(e, e, 'open')
--~ 	end
--~ end


local function openCell(p)
	Arkham.Map.setChar(p, ' ')
	Arkham.Map.setWalkable(p, true)
	Arkham.Map.setTransparent(p, true)
end

local function closeCell(p, char)
	Arkham.Map.setChar(p, char)
	Arkham.Map.setWalkable(p, false)
	Arkham.Map.setTransparent(p, false)
end


function update(e, dt)
	local msg = receiveMessage(e)
	
	if msg ~= nil then
		local pos = Arkham.Entity.getPosition(e)
		local data = scriptEntities[e]
	
		if msg.name == 'open' then
			if data.useRegion then
				for i, p in pairs(data.region) do
					openCell(p)
				end
			else
				openCell(pos)
			end
		elseif msg.name == 'close' then
			if data.useRegion then
				for i, p in pairs(data.region) do
					closeCell(p, scriptEntities[e].closedTile)
				end
			else
				closeCell(pos, scriptEntities[e].closedTile)
			end
		end
	end
end
