module('entity.fairy', package.seeall)


function init(e)
	scriptEntities[e] = {
		e = e,
		seed = 100 * math.random(),
		angle = 6.28 * math.random(),
		dist = 1 + math.abs(math.random()),
		speed = 2 + 1 * math.random(),
		origin = Arkham.Entity.getPosition(e)
	}
	if math.random(2) == 2 then
		scriptEntities[e].speed = -scriptEntities[e].speed
	end
	setupLight(e, 10, 2, Arkham.Entity.getColor(e))
	Arkham.Entity.setLightFade(e, 50)
end



function think(e)
	local data = scriptEntities[e]
	
	yield()
	
	while true do
		local time = data.seed + Arkham.getWorldTime()
		local dist = data.dist + 1.5 * Arkham.Perlin.noise1D(time + 9.7)
		local d = GridPos.make(
			dist * (math.cos(data.angle) + Arkham.Perlin.noise1D(time)),
			dist * (math.sin(data.angle) + Arkham.Perlin.noise1D(time + 7.12))
		)
		Arkham.Entity.setPosition(e, data.origin + d)
		data.angle = data.angle + data.speed * Arkham.getDeltaTime()
		yield()
	end
	
end
