module('entity.hillside_weather', package.seeall)


function init(e)
	scriptEntities[e] = {
		e = e,
		progress = 0,
		starty = Arkham.Map.getRegionCenter('start')[2],
		endy = Arkham.Map.getRegionCenter('exit_n')[2],
	}
	Arkham.Audio.playSoundLooped('sound/rainloop.ogg')
end


local function setBrightness(b)
	Arkham.setAmbientLight({b,b,b})
end

local function updateWeather(e, progress)
	local brightness = 192 - 160 * progress
	setBrightness(brightness)
	sendMessage(e, _e('lightning'), 'setIntensity', {intensity=progress})
end


function think(e)
	local data = scriptEntities[e]

	yield()
	textBox([[It was late that Sunday when Edward Digby finally reached the top of a hill from which he first laid eyes on the town of Reddenhurst. After spending what had seemed like days in that cursed post carriage, getting out onto his own two feet had felt almost like a relief. "No mail for Reddenhurst this week, sir," the coachman had informed him. The relief quickly washed away, however, as the first raindrops of a thunderstorm drawing near struck his forehead. Nonetheless, his destination being in sight at last felt reinvigorating. He pulled his coat tighter around his body and sped up his pace.]])
	
	while true do
		newProgress = (playerPos[2] - data.starty) / (data.endy - data.starty)
		if newProgress > data.progress then
			updateWeather(e, newProgress)
			data.progress = newProgress
		end
		yield()
	end
	
end
