module('entity.mayor', package.seeall)


function init(e)
	scriptEntities[e] = {
		e = e,
	}
end


function stepTowards(e, target)
	local pos = Arkham.Entity.getPosition(e)
	if GridPos.isAdjacent(pos, target) then
		return true
	else
		Arkham.Entity.moveTowards(e, target)
		return false
	end
end

function think(e)
	local door = _e('door_mayor')
	local doorPos = Arkham.Entity.getPosition(door)
	
	local greeted = false

	yield()
	
	while not stepTowards(e, playerPos) do
		yield()
		if not greeted and isEntityAdjacent(e, doorPos) then
			sendMessage(e, _e('door_mayor'), 'open')
			yield()
			textBox([["Mr Digby!" As Edward entered Reddenhurst, a portly man in an oilcloth raincoat scuffled out of the shadows beneath a nearby roof.]])
			greeted = true
		end
	end
	
	textBox([["You will recall our correspondence; I am Howard Philippson, mayor of Reddenhurst. I was worried whether you would make it here in this weather. We have made a reservation for a room for you in our local inn, just to your right. You should go there and warm yourself up and get a good night's rest. Tomorrow morning, I understand you will want to attend the funeral; the cemetery is located in the southwestern part of Reddenhurst, you really cannot miss it. If you have any questions, you may find me in my house here just across the main street from the inn at any time. For tonight, however, you will excuse me as it is late and it will do us both good to get out of the rain. May I again express my heartfelt sympathy for your loss -- and welcome to Reddenhurst."

And with that, he scurried off into the dark and wet and cold again.]])

	local home = Arkham.Map.getRegionCenter('house_mayor')
	while not stepTowards(e, home) do
		yield()
		if Arkham.Map.regionContains('house_mayor', e) and isEntityAdjacent(e, doorPos) then
			sendMessage(e, _e('door_mayor'), 'close')
			
		end
	end
	sendMessage(e, _e('door_mayor'), 'close')
end
