module('entity.player', package.seeall)


function init(e)
	scriptEntities[e] = {
		e = e,
		hasLeftStart = false,
		startRegion = startRegion
	}
	Arkham.Entity.setSpeed(e, 5.5)
	
	if startRegion then
		Arkham.Entity.setPosition(e, Arkham.Map.getRegionCenter(startRegion))
	else
		local start = Arkham.Map.getRegionCenter('start')
		if start ~= {0,0} then
			Arkham.Entity.setPosition(e, start)
		end
	end
end

function update(e, dt)
	local dir = Arkham.Input.getInputDirection()
	if dir ~= nil then
		Arkham.Entity.moveDirectional(e, dir)
	end
	
	-- scroll to player position
	Arkham.Map.setViewPoint(Arkham.Entity.getPosition(e))
	
	local data = scriptEntities[e]
	
	if data.hasLeftStart then
		checkExits(e)
	else
		if data.startRegion == nil or (not Arkham.Map.regionContains(data.startRegion, e)) then
			data.hasLeftStart = true
		end
	end
end

function checkExits(e)
	playerPos = Arkham.Entity.getPosition(e)
	
	for i, exit in pairs(exits) do
		if Arkham.Map.regionContains(exit.region, e) then
			Arkham.changeMap(exit.map)
			startRegion = exit.start
			return
		end
	end
end
