--
-- init.lua
--
-- Executed at engine startup.
--

require('util')
require('GridPos')


scriptEntities = {}

player = nil
playerPos = nil
exits = {}


function update(dt)
	playerPos = Arkham.Entity.getPosition(player)		-- for convenient access
end



function initWorld()
	player = Arkham.Entity.getEntityByName('player')

	local regions = Arkham.Map.getAllRegions()
	if regions then
		exits = parseExits(regions)
	end
end



function parseExits(regions)
	local exits = {}
	for i, rgn in pairs(regions) do
		if rgn:startsWith('exit') then
			local param = Arkham.Map.getRegionParameter(rgn)
			separ = param:find('\:')
			mapName = param:sub(1, separ-1)
			rgnName = param:sub(separ+1)
			table.insert(exits, {
				region = rgn,
				map = mapName .. '.amap',
				start = rgnName
			})
		end
	end
	return exits
end
